// 

#include "asmegam.h"
#include "lcd.h"
#include "adc.h"

void port_init(void) //    , LED0 = 1, LED1 = 0
{
	DDRD |= (LED0 | LED1);
	PORTD |= (LED0 | LED1);

	PORTD |= LED0;
	PORTD &= ~LED1;
	
	//   - ,   
	DDRF = 0;
	PORTF = 0;
}

void timer0_init(void) //   :      
{
	TCCR0 = 0x00; //     
	ASSR  = 0x08; //      
	TCNT0 = 0x00; // 
	TCCR0 = 0x04; // 
}

unsigned short value_hex, value_v; // hex =  , v -   

byte h1,h2,h3,d0,d1,d2,d3;

unsigned short save;
byte hex[16] = "0123457689abcdef";

void output_voltage(void) //    
{
	save = value_v;
	d0 = d1 = d2 = d3 = 0;
	while(save >= 1000)
		save -= 1000, d0++;
	while(save >= 100)
		save -= 100, d1++;
	while(save >= 10)
		save -= 10, d2++;
	d3 = save;
	
	d0 += '0';
	d1 += '0';
	d2 += '0';
	d3 += '0';

	h1 = hex[(value_hex>>8)&0x0f];
	h2 = hex[(value_hex>>4)&0x0f];
	h3 = hex[(value_hex)&0x0f];

	gotoxy(0,0);
	outtext("Ain0 = ");
	putchar(d0);
	putchar(',');
	putchar(d1);
	putchar(d2);
	putchar(d3);
	outtext(" V");

	gotoxy(0,1);
	outtext("HEX code = ");
	putchar(h1);
	putchar(h2);
	putchar(h3);
}

void timer(void) //  
{   
	PORTD ^= (LED0 | LED1); //     ("")

	ADC_Init_10bit(0,ADC_PRESCALER_64,0); //  0,    
	value_hex = ADC_GetValue_NR();

	// v*1000 = hex/1023*2.56  * 1000 = hex*10 / 4; (internal, 2.56V)
	//value_v = (value_hex*10+2)>>2;
	// v*1000 = hex/1023*5.00 * 1000 = hex*5000/1023; (external, 5.00V)

	value_v = (unsigned short)((((unsigned long)value_hex)*5000+511)/1023);  

	output_voltage(); // 
}         

// 

byte tick = 0;

#pragma interrupt_handler timer0_ovf_isr:17
void timer0_ovf_isr(void)
{
    if(tick ^= 1) //   , ..   -      ""
		timer();
}

void main(void) //  
{
	CLI(); //   
	XDIV  = 0x00; //  . ICCAVR AppBuilder
	XMCRA = 0x0A; //external memory
	XMCRB = 0x00;
	port_init();
	timer0_init();
	MCUCR = 0x00;
	EICRA = 0x00;
	EICRB = 0x00;
	EIMSK = 0x00;
	TIMSK = 0x01;
	ETIMSK = 0x00;
	
	init_lcd(); //    

	SEI();
	
	while(1) //  
		;
}
